	;; Generic crt0.s for trs-80 model3 trsdos/ldos
	.globl	_main
	.globl	s__DATA
	.globl	l__DATA
	.globl	s__ARGV

	.area	_CODE
init:
	;; Stack at the end of memory.
	ld	sp,(0x4411)

	;; Clear the data section.
	ld	bc,#l__DATA	;get len of data sect
	ld	a,b		;exit if zero len
	or	c
	jr	z,clrdn
	ld	hl,#s__DATA	;zero first byte
	ld	(hl),#0
	dec	bc		;bump count
	ld	a,b		;exit if only one byte len
	or	c
	jr	z,clrdn
	ld	e,l		;clear remaining
	ld	d,h
	inc	de
	ldir
clrdn:

	;; Put argv[] in argv section - not sure this is really safe since
	;; there is no memory allocated.  Probably okay with no dynamic
	;; memory allocation.
	ld	hl,#0x4225	;get addr of command line
	ld	de,#s__ARGV	;get addr of argv[]
	push	de		;stack argv
	ld	bc,#0		;init argc to 0
	dec	hl
argnxt:
	inc	hl		;get next char
	ld	a,(hl)
	or	a		;exit if null
	jr	z,argdn0
	cp	#13		;done if cr
	jr	z,argdn
	cp	#32		;loop past spaces
	jr	z,argnxt
	ld	a,l		;sto pointer in argv array
	ld	(de),a
	inc	de
	ld	a,h
	ld	(de),a
	inc	de
	inc	bc		;bump argc
argbmp:
	inc	hl		;get next char
	ld	a,(hl)
	or	a		;exit if null
	jr	z,argdn0
	cp	#13		;done if cr
	jr	z,argdn
	cp	#32		;loop until space
	jr	nz,argbmp
	ld	(hl),#0		;insert null in command line
	jr	argnxt		;do next parameter
argdn:
	ld	(hl),#0		;insert null
argdn0:
	push	bc		;stack argc
;	ld	(),de		;start of heap?

	;; Initialise global variables
	call	gsinit
	call	_main
	jp	0x402d

	;; Ordering of segments for the linker.
	.area	_GSINIT
	.area	_GSFINAL
	.area	_DATA
	.area	_BSS
	.area	_ARGV


	.area	_CODE

        ;; Special RLE decoder used for initing global data
__initrleblock::
        ;; Pop the return address
        pop     hl
        ;; Save registers
        push    bc
        push    de

        ;; Pull the destination address out
        ld      c,(hl)
        inc     hl
        ld      b,(hl)
        inc     hl
1$:
        ;; Fetch the run
        ld      e,(hl)
        inc     hl
        ;; Negative means a run
        bit     7,e
        jp      z,2$
        ;; Code for expanding a run
        ld      a,(hl)
        inc     hl
3$:
        ld      (bc),a
        inc     bc
        inc     e
        jp      nz,3$
        jp      1$
2$:
        ;; Zero means end of a block
        xor     a
        or      e
        jp      z,4$
        ;; Code for expanding a block
5$:
        ld      a,(hl)
        inc     hl
        ld      (bc),a
        inc     bc
        dec     e
        jp      nz,5$
        jp      1$
4$:
        pop     de
        pop     bc

        ;; Push the return address back onto the stack
        push    hl
        ret

        .area   _GSINIT
gsinit::

        .area   _GSFINAL
        ret
